
/* score_read.c - read data from score */

#include "main.h"

/* read all notes from score */

void	read_score (void)
{
	int	i, j, size;
	char	*s;

	free_list ();
	nr_events = size = 0;
	do {
		if (nr_events >= size) {
			event_list = (score_event *)
				     realloc (event_list, sizeof (score_event)
							  * (size += 64));
			if (event_list == NULL)
				err_msg ("not enough memory", -1);
		}
		i = get_statement (in_file, &s,	/* read a line from score */
				   &(event_list[nr_events].p_list));
		if ((i < 1) || (strcmp (s, "i"))) {	/* no valid	*/
			if (s != NULL) {		/* i-statement	*/
				free (s); s = NULL;	/* was found	*/
			}
			if (event_list[nr_events].p_list != NULL) {
				free (event_list[nr_events].p_list);
				event_list[nr_events].p_list = NULL;
			}
			if (i < 0) {			/* end of file */
				if ((!(nr_events)) && (event_list != NULL)) {
					free (event_list); event_list = NULL;
				}
				break;
			}
			continue;
		}
		if (s != NULL) {
			free (s); s = NULL;
		}
		if (i > 4) {				/* skip field 5 of */
			j = 4; while (++j < i)		/* sorted score    */
				event_list[nr_events].p_list[j - 1] =
					event_list[nr_events].p_list[j];
			i--;
		}
		if (i > 2) {				/* skip field 3 of */
			j = 2; while (++j < i)		/* sorted score    */
				event_list[nr_events].p_list[j - 1] =
					event_list[nr_events].p_list[j];
			i--;
		}
		if (i > P_MAX) err_msg ("too many p-fields in score", -1);
		event_list[nr_events].p_list =
			(double*) realloc ((void*) event_list[nr_events].p_list,
					   sizeof (double) * i);
		event_list[nr_events].nr_pfields = i;
		event_list[nr_events].time_ofs = 0.0;
		event_list[nr_events].end_ofs = 0.0;
		nr_events++;
	} while (1);
}

/* free memory used by event list */

void	free_list (void)
{
	if (event_list == NULL) return;
	while (--nr_events >= 0)
		if (event_list[nr_events].p_list != NULL) {
			free (event_list[nr_events].p_list);
			event_list[nr_events].p_list = NULL;
		}
	free (event_list); event_list = NULL;
	nr_events = 0;
}

